/* classes: src_files */

/*	Copyright (C) 1994 Free Software Foundation, Inc.

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this software; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */



/* {The Guile Kitchen Sink}
 * 
 * An initialization function for "Guile with everything."
 */

#include <stdio.h>
#include <sys/param.h>
#include "guile.h"
#include "setjump.h"



/* {Initialization}
 */

void
guile_ks ()
{
  scm_init_ioext();
#if 0
  scm_init_pty();
#endif
  scm_init_posix();
  scm_init_socket();
  scm_init_unix();
  scm_init_rgx();
  scm_init_guile();
  scm_init_ctax();
  scm_init_fastio();
  scm_init_lreader();
#if HAVE_GTCLTK
  scm_init_tcl();
  scm_init_tk();
#endif
  scm_init_mallocs();
  scm_init_struct();
  scm_init_bytecode();
}




GSCM_status
initialize_gscm (initfile, argc, argv)
     char *initfile;
     int argc;
     char **argv;
{
  return gscm_init_from_fn (initfile, argc, argv, guile_ks);
}
